import { Component, Input, EventEmitter, Output, OnInit } from '@angular/core'

@Component({
	// eslint-disable-next-line @angular-eslint/component-selector
	selector: 'sui-button',
	templateUrl: './button.component.html'
})
export class SuiButtonComponent implements OnInit {
	@Input() ariaLabel: string = 'button'
	@Input() disabled: boolean = false
	@Input() tabLevel = '0'
	@Output() callBack = new EventEmitter<any>()

	@Input() title: string = 'button'
	@Input() color: string = ''
	@Input() size: string = ''
	@Input() class: string = ''
	@Input() fullWidth: boolean = false
	@Input() iconType: string = 'cross'

	buttonSize: string = ''
	buttonColor: string = ''
	buttonBaseStyles: string =
		'px-6 font-medium text-center rounded-lg duration-300;'
	iconSize: string = ''
	@Output() buttonWidth: string = '' 

	calculateWidth(fullWidth: boolean) {
		if (fullWidth == true) {
			return this.buttonWidth = 'w-full'
		} else {
			return this.buttonWidth = ''
		}
	}

	calculateSize(size: string) {
		if (size == 'small') {
			return (this.buttonSize =
				'py-1.5 text-sm leading-normal ' + this.buttonBaseStyles)
		} else if (size == 'medium') {
			return (this.buttonSize = 'py-2 text-md ' + this.buttonBaseStyles)
		} else if (size == 'large') {
			return (this.buttonSize = 'py-3 ' + this.buttonBaseStyles)
		} else {
			return (this.buttonSize = 'py-2 text-md ' + this.buttonBaseStyles)
		}
	}

	calculateColor(color: string) {
		if (color === 'primary') {
			return (this.buttonColor =
				'text-light-c1 dark:text-dark-c1 bg-light-c6 dark:bg-dark-c6 hover:bg-alerts-hover-primary hover:dark:bg-alerts-hover-primary2')
		} else if (color === 'ghost') {
			return (this.buttonColor =
				'text-light-c5 dark:text-dark-c5 border border-light-c4_10 dark:border-dark-c4_10 hover:bg-light-c2 hover:dark:bg-dark-c2')
		} else if (color === 'empty') {
			return (this.buttonColor =
				'text-light-c5 dark:text-dark-c5 hover:bg-light-c2 hover:dark:bg-dark-c2')
		} else if (color === 'success') {
			return (this.buttonColor =
				'text-alerts-success-text bg-alerts-success-background hover:bg-alerts-hover-success')
		} else if (color === 'info') {
			return (this.buttonColor =
				'text-alerts-info-text bg-alerts-info-background hover:bg-alerts-hover-info')
		} else if (color === 'danger') {
			return (this.buttonColor =
				'text-alerts-danger-text bg-alerts-danger-background hover:bg-alerts-hover-danger')
		} else if (color === 'warning') {
			return (this.buttonColor =
				'text-alerts-warning-text bg-alerts-warning-background hover:bg-alerts-hover-warning')
		} else {
			return (this.buttonColor =
				'text-light-c1 dark:text-dark-c1 bg-light-c6 dark:bg-dark-c6 hover:bg-light-c2 hover:dark:bg-dark-c2 hover:bg-alerts-hover-primary')
		}
	}

	calculateIconSize(size: string) {
		if (size == 'small') {
			return (this.iconSize = 'h-2 w-2')
		} else if (size == 'medium') {
			return (this.iconSize = 'h-4 w-4')
		} else if (size == 'large') {
			return (this.iconSize = 'h-6 w-6')
		} else {
			return (this.iconSize = 'h-8 w-8')
		}
	}

	constructor() {}

	ngOnInit(): void {}
}
