import { Component, Input, OnInit } from '@angular/core'

interface Icon {
	name: string
}

@Component({
	// eslint-disable-next-line @angular-eslint/component-selector
	selector: 'sui-icon',
	templateUrl: './icons.component.html',
	styleUrls: ['./icons.component.scss']
})
export class SuiIconsComponent implements OnInit {
	iconColor: string = ''
	iconSize: string = ''
	iconHoverColor: string = ''

	@Input() type: string = ''
	@Input() size: string = ''
	@Input() color: string = ''
	@Input() hoverColor: string = ''

	calculateType(type: string) {
		return `./assets/icons/${type}.svg`
	}

	calculateColor(color: string) {
		if (color === 'muted') {
			return (this.iconColor = 'fill-light-c4 dark:fill-dark-c4')
		} else if (color === 'text') {
			return (this.iconColor = 'fill-light-c5 dark:fill-dark-c5')
		} else if (color === 'danger') {
			return (this.iconColor = 'fill-alerts-danger-text')
		} else if (color === 'success') {
			return (this.iconColor = 'fill-alerts-success-text')
		} else if (color === 'info') {
			return (this.iconColor = 'fill-alerts-info-text')
		} else if (color === 'warning') {
			return (this.iconColor = 'fill-alerts-warning-text')
		} else if (color === 'primary') {
			return (this.iconColor = 'fill-light-c6 dark:fill-dark-c6')
		} else {
			return (this.iconColor = 'fill-light-c5 dark:fill-dark-c5')
		}
	}

	calculateHoverColor(hoverColor: string) {
		if (hoverColor === 'muted') {
			return (this.iconHoverColor =
				'hover:fill-light-c4 dark:hover:fill-dark-c4')
		} else if (hoverColor === 'text') {
			return (this.iconHoverColor =
				'hover:fill-light-c5 dark:hover:fill-dark-c5')
		} else if (hoverColor === 'danger') {
			return (this.iconHoverColor = 'hover:fill-alerts-danger-text')
		} else if (hoverColor === 'success') {
			return (this.iconHoverColor = 'hover:fill-alerts-success-text')
		} else if (hoverColor === 'info') {
			return (this.iconHoverColor = 'hover:fill-alerts-info-text')
		} else if (hoverColor === 'warning') {
			return (this.iconHoverColor = 'hover:fill-alerts-warning-text')
		} else if (hoverColor === 'primary') {
			return (this.iconHoverColor =
				'hover:fill-light-c6 dark:hover:fill-dark-c6')
		} else {
			return (this.iconHoverColor =
				'hover:fill-light-c5 dark:hover:fill-dark-c5')
		}
	}

	calculateSize(size: string) {
		if (size == 'x-small') {
			return (this.iconSize = 'h-3.5 w-3.5')
		} else if (size == 'small') {
			return (this.iconSize = 'h-5 w-5')
		} else if (size == 'medium') {
			return (this.iconSize = 'h-6 w-6')
		} else if (size == 'large') {
			return (this.iconSize = 'h-8 w-8')
		} else if (size == 'x-large') {
			return (this.iconSize = 'h-10 w-10')
		} else if (size == 'xx-large') {
			return (this.iconSize = 'h-16 w-16')
		} else {
			return (this.iconSize = 'h-6 w-6')
		}
	}

	constructor() {}

	ngOnInit(): void {}
}
