import { Component, Input, OnInit } from '@angular/core'

@Component({
	// eslint-disable-next-line @angular-eslint/component-selector
	selector: 'sui-title',
	templateUrl: './title.component.html',
	styleUrls: ['../../styles.css', ]
})
export class SuiTitleComponent implements OnInit {
	@Input() size: string = 'x-large'
	@Input() color: string = 'vibrant'

	tone: string = ''
	calculateColor(color: string) {
		if (color == 'muted') {
			return (this.tone = 'text-light-c4 dark:text-dark-c4')
		} else {
			return (this.tone = 'text-light-c5 dark:text-dark-c5')
		}
	}

	baseStyle: string = 'font-bold ' + this.tone

	calculateStyles(size: string) {
		if (size == 'xx-small') {
			return 'text-sm uppercase ' + this.baseStyle
		} else if (size == 'x-small') {
			return 'text-md ' + this.baseStyle
		} else if (size == 'small') {
			return 'text-lg ' + this.baseStyle
		} else if (size == 'medium') {
			return 'text-xl ' + this.baseStyle
		} else if (size == 'large') {
			return 'text-2xl ' + this.baseStyle
		} else if (size == 'x-large') {
			return 'text-4xl ' + this.baseStyle
		} else {
			return 'medium primary'
		}
	}

	constructor() {}

	ngOnInit(): void {}
}
